#include <QApplication>
#include <QTreeWidget>
#include <QMainWindow>
#include <QVBoxLayout>
#include <QPushButton>

int main(int argc, char** argv) {
    QApplication a(argc, argv);

    QTreeWidget* treeWidget = new QTreeWidget;
    treeWidget->setColumnCount(4);

    auto populate = [&](int amount) {
        for (int i = 0; i < amount; i++) {
            auto item = new QTreeWidgetItem(treeWidget);
            auto text = "Item " + QString::number(i);
            item->setText(0, text);
            item->setText(1, text);
            item->setText(2, text);
            item->setText(3, text);
        }
    };

    populate(15);

    QPushButton* pushButton = new QPushButton("Works");
    QObject::connect(pushButton, &QPushButton::clicked, [&]() {
        treeWidget->clear();
        populate(15);
        for (int i = 0; i < 4; ++i) {
            treeWidget->resizeColumnToContents(i);
        }
        treeWidget->sortByColumn(0, Qt::DescendingOrder);
    });

    QPushButton* pushButton2 = new QPushButton("Broken");
    QObject::connect(pushButton2, &QPushButton::clicked, [&]() {
        treeWidget->clear();
        populate(10);
        for (int i = 0; i < 4; ++i) {
            treeWidget->resizeColumnToContents(i);
        }
        treeWidget->sortByColumn(0, Qt::DescendingOrder);
    });

    QVBoxLayout* layout = new QVBoxLayout;
    layout->addWidget(treeWidget);
    layout->addWidget(pushButton);
    layout->addWidget(pushButton2);

    QWidget* centralWidget = new QWidget;
    centralWidget->setLayout(layout);

    QMainWindow w;
    w.setCentralWidget(centralWidget);
    w.show();
    w.setGeometry(w.x(), w.y(), 500, 400);


    return a.exec();
}
